﻿class CApplication;

class CThreadWrapper : public Obelisk::IThreadObelisk
{
public:
	CThreadWrapper(CApplication* aApplication, Obelisk::IThread* aThread);
	~CThreadWrapper();

	void Run();
	void Stop();

	bool IsStopped();

	Obelisk::CString IntToString(int aNumber, int aLeading0s);
	void NotifyWindow(int aMessage, int aData);

	double Random();
	int Random(int aMin, int aMax);

	void AttachRenderingContext();

	bool LoadTexture(Obelisk::CString aName, bool aTransparent);

	bool LoadSound(Obelisk::CString aName);

	Obelisk::IReader* OpenDataFile(Obelisk::CString aFileName);
	Obelisk::IReader* ReadUserFile(Obelisk::CString aFileName);
	Obelisk::IWriter* WriteUserFile(Obelisk::CString aFileName);

private:
	CApplication *mApplication;
	Obelisk::IThread *mThread;

	HANDLE mThreadHandle;
	HANDLE mStopped;
	bool mIOStopped;
	static DWORD WINAPI ThreadProc(LPVOID lpParameter);
	void ThreadMain();
};