﻿class CGameController;

class CMainController : public Obelisk::IMainController
{
public:
	CMainController(Obelisk::IObelisk* aObelisk);
	~CMainController();

	void Initialise();

	void OnNotify(int aMessage, int aData);
	void OnTimer();
	void OnDeactivate();
	void OnActivate();

	void OnKeyDown(Obelisk::EKey aKey);
	void OnKeyUp(Obelisk::EKey aKey);

	void ThreadFinished(Obelisk::IThread* aThread);

	void SetFont0() { mObelisk->SetFont(mFont0); }

	bool GetPaused() { return mPaused; }

	bool IsEnterPressed();
	bool IsEscapePressed();

private:
	Obelisk::IObelisk *mObelisk;

	bool mPaused;

	CGameController *mGame;

	bool mState;   // false: title screen, true: game
	Obelisk::CStringMap<Obelisk::CTexture> mFont0;

	bool mEnterDownLast;
	bool mEscapeDownLast;
};