﻿#include "Obelisk.h"

#include "CScriptEngine.h"
#include "IScript.h"
#include "CScriptCutscene.h"

using namespace Obelisk;



CScriptCutscene::CScriptCutscene(int aCutscene)
{
	mCutscene = aCutscene;
	mStage = 0;
}


int gNumStages[] = { 8, 2, 2, 2, 2 };



bool CScriptCutscene::Update(bool& aResult, IObelisk* aObelisk, CScriptEngine* aEngine)
{
	aResult = mStage < gNumStages[mCutscene];
	if (aObelisk->MouseButtonClicked(false) || aEngine->IsEnterPressed())
		mStage++;
	if (aEngine->IsEscapePressed())
		mStage = gNumStages[mCutscene];
	return mStage == gNumStages[mCutscene];
}



void CScriptCutscene::Render(IObelisk* aObelisk, CScriptEngine* aEngine)
{
	if (mCutscene == 0)
	{
		switch (mStage)
		{
			case 0:
				aEngine->ShowProfileCut(pBadGuy, 1);
				aEngine->ShowTextCut(1, 0, SL("Bad Guy:"));
				aEngine->ShowTextCut(1, 1, SL("Hello Gentlemen."));
				break;
			case 1:
				aEngine->ShowProfileCut(pBadGuy, 1);
				aEngine->ShowTextCut(1, 0, SL("All your oil are belong to... Me."));
				break;
			case 2:
				aEngine->ShowProfileCut(pBadGuy, 1);
				aEngine->ShowTextCut(1, 0, SL("Except for that island you just stole from"));
				aEngine->ShowTextCut(1, 1, SL("me. But I have plenty more and you'll"));
				aEngine->ShowTextCut(0, 2, SL("never be able to find me!"));
				break;
			case 3:
				aEngine->ShowProfileCut(pBadGuy, 1);
				aEngine->ShowTextCut(1, 0, SL("MUHAHAHAHA!"));
				break;
			case 4:
				aEngine->ShowProfileCut(pCmdr, 0);
				aEngine->ShowTextCut(0, 0, SL("Commander A. R. Sole:"));
				aEngine->ShowTextCut(0, 1, SL("As I suspected..."));
				break;
			case 5:
				aEngine->ShowProfileCut(pYou, 1);
				aEngine->ShowTextCut(1, 0, SL("Captain Chad Darington:"));
				aEngine->ShowTextCut(1, 1, SL("You know that guy?"));
				break;
			case 6:
				aEngine->ShowProfileCut(pCmdr, 0);
				aEngine->ShowTextCut(0, 0, SL("Commander A. R. Sole:"));
				aEngine->ShowTextCut(0, 1, SL("He's my arch nemesis. I've filed a lawsuit against"));
				aEngine->ShowTextCut(0, 2, SL("him but it's currently in the discovery process."));
				break;
			case 7:
				aEngine->ShowProfileCut(pCmdr, 0);
				aEngine->ShowTextCut(0, 0, SL("Looks like we'll have to deal to him the old-"));
				aEngine->ShowTextCut(0, 1, SL("fashioned way."));
				break;
		}
	}
	else if (mCutscene == 1)
	{
		switch (mStage)
		{
			case 0:
				aEngine->ShowProfileCut(pBadGuy, 1);
				aEngine->ShowTextCut(1, 0, SL("Bad Guy:"));
				aEngine->ShowTextCut(1, 1, SL("You again?"));
				break;
			case 1:
				aEngine->ShowProfileCut(pBadGuy, 1);
				aEngine->ShowTextCut(1, 0, SL("You know, you're uglier than some animals"));
				aEngine->ShowTextCut(1, 1, SL("I've seen on the Discovery Channel."));
				break;
		}
	}
	else if (mCutscene == 2)
	{
		switch (mStage)
		{
			case 0:
				aEngine->ShowProfileCut(pBadGuy, 1);
				aEngine->ShowTextCut(1, 0, SL("Bad Guy:"));
				aEngine->ShowTextCut(1, 1, SL("You're getting closer. In fact I can smell"));
				aEngine->ShowTextCut(1, 2, SL("you."));
				break;
			case 1:
				aEngine->ShowProfileCut(pBadGuy, 1);
				aEngine->ShowTextCut(1, 0, SL("You smell like rotten discovery apples."));
				break;
		}
	}
	else if (mCutscene == 3)
	{
		switch (mStage)
		{
			case 0:
				aEngine->ShowProfileCut(pBadGuy, 1);
				aEngine->ShowTextCut(1, 0, SL("Bad Guy:"));
				aEngine->ShowTextCut(1, 1, SL("What's taking you so long?"));
				break;
			case 1:
				aEngine->ShowProfileCut(pBadGuy, 1);
				aEngine->ShowTextCut(1, 0, SL("You're slower than a broken down Land"));
				aEngine->ShowTextCut(1, 1, SL("Rover Discovery!"));
				break;
		}
	}
	else if (mCutscene == 4)
	{
		switch (mStage)
		{
			case 0:
				aEngine->ShowProfileCut(pBadGuy, 1);
				aEngine->ShowTextCut(1, 0, SL("Bad Guy:"));
				aEngine->ShowTextCut(1, 1, SL("OK, you're close now. But you'll never get"));
				aEngine->ShowTextCut(1, 2, SL("past my defences!"));
				break;
			case 1:
				aEngine->ShowProfileCut(pBadGuy, 1);
				aEngine->ShowTextCut(1, 0, SL("I might as well be on the Space Shuttle"));
				aEngine->ShowTextCut(1, 1, SL("Discovery because you'll never get me."));
				break;
		}
	}
}